You can not select more than 25 topics
Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
114 lines
4.0 KiB
114 lines
4.0 KiB
From 573f0d46cff15fff2804b3fb444d1e34f482e788 Mon Sep 17 00:00:00 2001
|
|
From: Vishal Verma <vishal.l.verma@intel.com>
|
|
Date: Tue, 30 Mar 2021 20:54:55 -0600
|
|
Subject: [PATCH 016/217] libndctl: check for active system-ram before
|
|
disabling daxctl devices
|
|
|
|
Teach ndctl_namespace_disable_safe() to look at the state of a
|
|
daxctl_dev with respect to whether it is active in 'system-ram' mode
|
|
before disabling it. This is similar to checking whether a filesystem is
|
|
actively mounted on a namespace before disabling it.
|
|
|
|
Without this, libndctl would happily disable a devdax namespace while the
|
|
device was active in system-ram mode. If the namespace was subsequently
|
|
also destroyed, this would leave the memory without any sort of a
|
|
'handle' to perform any subsequent operation on it, and the system would
|
|
have to be rebooted to get out of this situation.
|
|
|
|
Reported-by: Chunye Xu <chunye.xu@intel.com>
|
|
Cc: Dan Williams <dan.j.williams@intel.com>
|
|
Cc: Dave Hansen <dave.hansen@linux.intel.com>
|
|
Signed-off-by: Vishal Verma <vishal.l.verma@intel.com>
|
|
---
|
|
ndctl/lib/libndctl.c | 25 ++++++++++++++++++++++++-
|
|
test/daxctl-devices.sh | 16 ++++++++++++++++
|
|
2 files changed, 40 insertions(+), 1 deletion(-)
|
|
|
|
diff --git a/ndctl/lib/libndctl.c b/ndctl/lib/libndctl.c
|
|
index 2f6d806..2eda56c 100644
|
|
--- a/ndctl/lib/libndctl.c
|
|
+++ b/ndctl/lib/libndctl.c
|
|
@@ -4593,21 +4593,40 @@ NDCTL_EXPORT int ndctl_namespace_disable_invalidate(struct ndctl_namespace *ndns
|
|
return ndctl_namespace_disable(ndns);
|
|
}
|
|
|
|
+static int ndctl_dax_has_active_memory(struct ndctl_dax *dax)
|
|
+{
|
|
+ struct daxctl_region *dax_region;
|
|
+ struct daxctl_dev *dax_dev;
|
|
+
|
|
+ dax_region = ndctl_dax_get_daxctl_region(dax);
|
|
+ if (!dax_region)
|
|
+ return 0;
|
|
+
|
|
+ daxctl_dev_foreach(dax_region, dax_dev)
|
|
+ if (daxctl_dev_has_online_memory(dax_dev))
|
|
+ return 1;
|
|
+
|
|
+ return 0;
|
|
+}
|
|
+
|
|
NDCTL_EXPORT int ndctl_namespace_disable_safe(struct ndctl_namespace *ndns)
|
|
{
|
|
const char *devname = ndctl_namespace_get_devname(ndns);
|
|
struct ndctl_ctx *ctx = ndctl_namespace_get_ctx(ndns);
|
|
struct ndctl_pfn *pfn = ndctl_namespace_get_pfn(ndns);
|
|
struct ndctl_btt *btt = ndctl_namespace_get_btt(ndns);
|
|
+ struct ndctl_dax *dax = ndctl_namespace_get_dax(ndns);
|
|
const char *bdev = NULL;
|
|
+ int fd, active = 0;
|
|
char path[50];
|
|
- int fd;
|
|
unsigned long long size = ndctl_namespace_get_size(ndns);
|
|
|
|
if (pfn && ndctl_pfn_is_enabled(pfn))
|
|
bdev = ndctl_pfn_get_block_device(pfn);
|
|
else if (btt && ndctl_btt_is_enabled(btt))
|
|
bdev = ndctl_btt_get_block_device(btt);
|
|
+ else if (dax && ndctl_dax_is_enabled(dax))
|
|
+ active = ndctl_dax_has_active_memory(dax);
|
|
else if (ndctl_namespace_is_enabled(ndns))
|
|
bdev = ndctl_namespace_get_block_device(ndns);
|
|
|
|
@@ -4632,6 +4651,10 @@ NDCTL_EXPORT int ndctl_namespace_disable_safe(struct ndctl_namespace *ndns)
|
|
devname, bdev, strerror(errno));
|
|
return -errno;
|
|
}
|
|
+ } else if (active) {
|
|
+ dbg(ctx, "%s: active as system-ram, refusing to disable\n",
|
|
+ devname);
|
|
+ return -EBUSY;
|
|
} else {
|
|
if (size == 0)
|
|
/* No disable necessary due to no capacity allocated */
|
|
diff --git a/test/daxctl-devices.sh b/test/daxctl-devices.sh
|
|
index eed5906..56c9691 100755
|
|
--- a/test/daxctl-devices.sh
|
|
+++ b/test/daxctl-devices.sh
|
|
@@ -105,6 +105,22 @@ daxctl_test()
|
|
"$DAXCTL" reconfigure-device -f -m devdax "$daxdev"
|
|
[[ $(daxctl_get_mode "$daxdev") == "devdax" ]]
|
|
|
|
+ # fail 'ndctl-disable-namespace' while the devdax namespace is active
|
|
+ # as system-ram. If this test fails, a reboot will be required to
|
|
+ # recover from the resulting state.
|
|
+ test -n "$testdev"
|
|
+ "$DAXCTL" reconfigure-device -m system-ram "$daxdev"
|
|
+ [[ $(daxctl_get_mode "$daxdev") == "system-ram" ]]
|
|
+ if ! "$NDCTL" disable-namespace "$testdev"; then
|
|
+ echo "disable-namespace failed as expected"
|
|
+ else
|
|
+ echo "disable-namespace succeded, expected failure"
|
|
+ echo "reboot required to recover from this state"
|
|
+ return 1
|
|
+ fi
|
|
+ "$DAXCTL" reconfigure-device -f -m devdax "$daxdev"
|
|
+ [[ $(daxctl_get_mode "$daxdev") == "devdax" ]]
|
|
+
|
|
# this tests for reconfiguration failure if an online-policy is set
|
|
set_online_policy
|
|
: "This command is expected to fail:"
|
|
--
|
|
2.27.0
|
|
|